   import java.awt.* ;

    public class ObjetFourmiOuvriere extends ObjetFourmi {
   
      private double vitesse = 2.0 ;
   
       public ObjetFourmiOuvriere(Simulation s, ObjetFourmiliere f, int x0, int y0, int id0, int idgrp0){
         super (s, f, x0, y0, id0, idgrp0);
      }
   
       public ObjetFourmiOuvriere(Simulation s, ObjetFourmiliere f, int x0, int y0, int sens, int id0, int idgrp0){
         super (s, f, x0, y0, sens, id0, idgrp0);
      }
   
   //------------------------------------------------------------
   /** 
   * simulation de l'objet
   */
   
       public void run() {
      
         switch (etatSecondaire) {
            case ETAT_CONTOURNEMENT_DROITE :
               roty += (float)45.0 ;
               break ;
            case ETAT_CONTOURNEMENT_GAUCHE :
               roty -= (float)45.0 ;
               break ;
            case ETAT_TOUT_DROIT :
               break;
            case ETAT_RETOUR :
               roty = (180/Math.PI)*Math.atan((fourmiliere.getX()-x)/(fourmiliere.getY()-y));
               if (((fourmiliere.getX()-x)<0) && ((fourmiliere.getY()-y)>0)) roty+=180;
               if (((fourmiliere.getX()-x)>0) && ((fourmiliere.getY()-y)>0)) roty+=180;
               break;
            case ETAT_SUIT_PHEROMONE :
               roty = (180/Math.PI)*Math.atan((pheromone.getXn()-x)/(pheromone.getYn()-y));
               if (((pheromone.getXn()-x)<0) && ((pheromone.getYn()-y)>0)) roty+=180;
               if (((pheromone.getXn()-x)>0) && ((pheromone.getYn()-y)>0)) roty+=180;
               break;
            default :
               if (Math.random()<0.1) {
                  roty += (float)(Math.random()*90.0-45.0);
               }
               break ;
         }
      
      // Pour faire coincider le modele de simulation avec le
      // modele 3D, qui utilisent le meme angle de rotation roty,
      // il faut calculer l'angle de rotation de la fourmi en 
      // ajoutant +90 degrs  roty (angle utilis pour la 3D)
      // et retrancher l'incrment sur l'axe des y...
         double angley = (roty+90)*Simulation.CONV_DEG_RAD ;
         double dx = vitesse*Math.cos(angley) ;
         double dy = vitesse*Math.sin(angley) ;
      
         switch (etatPrimaire) {
         
            case ETAT_AU_NID :
            
               if (etatSecondaire<10){
                  etatSecondaire++;
               }
               else{
                  if (charge!=0)
                     fourmiliere.ajouteStock(charge);
                  charge = 0;
                  etatSecondaire=0;
                  roty+=180;
                  etatPrimaire = ETAT_RECHERCHE_NOURRITURE;
               }
               break;
         
            case ETAT_RECHERCHE_NOURRITURE :
            
               x += dx ;
               y -= dy ;
            	
            	// Si je rencontre de la nourriture           
               if (((nourriture=(ObjetNourriture)simu.isNourriture(x, y)) != null) && (nourriture.getContenu()>0) ) {
                  etatSecondaire = 0;
                  etatPrimaire = ETAT_COLLECTE_NOURRITURE;
               }
                  
                  
                  // Si je rencontre un obstacle ou les limites du terrain
               else if ( (x<0) || (y<0) || (x>simu.getLargeur()) || (y>simu.getProfondeur()) || (simu.isObstacle(x, y)!=null) ) {
                  x -= dx ; 
                  y += dy ;
                  if (Math.random()<0.5) 
                     etatSecondaire = ETAT_CONTOURNEMENT_DROITE ;
                  else
                     etatSecondaire = ETAT_CONTOURNEMENT_GAUCHE ;
               }
                  
                  // Si je rencontre une phromone
               else if ( (pheromone=(ObjetPheromone)simu.isPheromone(x, y)) != null){
                  if (((nourriture=(ObjetNourriture)simu.isNourriture(pheromone.getXn(), pheromone.getYn())) != null) && (nourriture.getContenu()>0) ){
                     etatSecondaire = ETAT_SUIT_PHEROMONE;
                  }
               }
                  
               else etatSecondaire = 0 ;
               
               break;
         
            case ETAT_COLLECTE_NOURRITURE :
            
               synchronized (nourriture) {
                  if (etatSecondaire<50){
                  //                      if (simu.listeObjetsVisibles.indexOf (nourriture)!=-1) {
                     if (nourriture.getContenu()>0){
                        etatSecondaire++;           
                        charge++;
                        nourriture.enleveContenu();
                     }
                     else etatSecondaire=50;     
                  }
                  else{
                     etatPrimaire = ETAT_RAMENE_NOURRITURE;
                     etatSecondaire = 0;
                     etatTernaire = 0;
                  //                   if (simu.listeObjetsVisibles.indexOf (nourriture)!=-1) {
                  //                         if (nourriture.getContenu()<=0) {
                  //                            simu.suppNourriture (nourriture); 
                  //                         }
                  //                      }
                  }
               }
               break;
         
            case ETAT_RAMENE_NOURRITURE :
            
               if ( (Math.abs(x-fourmiliere.getX())<vitesse) && (Math.abs(y-fourmiliere.getY())<vitesse) ){
                  System.out.println("Fourmi "+getId()+"("+getIdGroup()+") : Je suis au nid");
                  etatPrimaire = ETAT_AU_NID;
               }
               else{
               
                  simu.poserPheromone (this, nourriture);
               	//System.out.println("Fourmi "+getId()+"("+getIdGroup()+")"+" : Je pose une phromone");
               
                  x += dx ;
                  y -= dy ;
               
                  if (etatTernaire==0) {                  
                     if ( (x<0) || (y<0) || (x>simu.getLargeur()) || (y>simu.getProfondeur()) || (simu.isObstacle(x, y)!=null) ) {
                        x -= dx ; 
                        y += dy ;
                        if (Math.random()<0.5)
                           roty+=90;
                        else
                           roty-=90;
                        etatTernaire = 10;
                     
                        etatSecondaire = ETAT_TOUT_DROIT ;
                     }
                     else{	                     
                        etatSecondaire = ETAT_RETOUR;
                     }
                  }
                  else {
                     etatTernaire--;
                  }
               	
                  break;
               
               }
         }
      }
   
   //------------------------------------------------------------
   /** 
   * Dessin 2D de l'objet 
   */
       public void draw(Graphics g, double facteurZoom) {
         g.setColor(new Color (getRed(), getGreen(), getBlue()));
         g.fillRect((int)(x*facteurZoom), (int)(y*facteurZoom), 
               (int)(2*(facteurZoom+1)), (int)(2*(facteurZoom+1))) ;
      }
   }
