//------------------------------------------------------------
/**
 * Classe ObjetFourmiliere
 *
 *
 * Copyright (C) 2004  Olivier Grunder
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; see the file COPYING.  If not, write to
 *   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA 02111-1307, USA.
 *
 *   Contact: Olivier Grunder, 
 *            mailto:olivier.grunder@utbm.fr
 *            http://set.utbm.fr/membres/grunder/
 *
 *
 * @author      Olivier Grunder 
 * @date        janvier 2004
 * @version     0.22
 */

   import java.awt.* ;

    public class ObjetFourmiliere extends ObjetVisible {
   
   /* Attributs pour la nourriture */
      private int stock=0;
   
   /* Nombre de fourmis que je gre */
      private int population;
   
      double oldfacteurZoom=-1 ;
   
   /** 
   * Constructeur 
   *
   * @param x0                coord x de la fourmiliere
   * @param y0                coord y de la fourmiliere
   * @param id0               numero de la fourmiliere (dfinit sa couleur)
   */
   
       public ObjetFourmiliere(int x0, int y0, int id0){
      
         super (x0, y0, id0, 0) ;
         type = FOURMILIERE ;
         setColor(Objet.RED[id0], Objet.GREEN[id0], Objet.BLUE[id0]) ;
         scale = 2.0 ;
      }
   
       public ObjetFourmiliere(int x0, int y0, double ry, int id0){
      
         super (x0, y0, ry, 2.0, id0, 0) ;
         type = FOURMILIERE ;
         setColor(Objet.RED[id0], Objet.GREEN[id0], Objet.BLUE[id0]) ;   
      }
   
       public ObjetFourmiliere(int x0, int y0, double ry, int id0, int pop){
      
         super (x0, y0, ry, 2.0, id0, 0) ;
         population = pop ;
         type = FOURMILIERE ;
         setColor(Objet.RED[id0], Objet.GREEN[id0], Objet.BLUE[id0]) ;   
      }
   
   
   //------------------------------------------------------------
   /** 
   * simulation de l'objet
   */
   
       public void run() {
      
      
      
      }
   
       public int getStock (){
         return stock;
      }
   
       public void ajouteStock (int qte){
         stock+=qte;
         System.out.println ("Fourmiliere "+id+" : nouveau stock = "+stock+" (+"+qte+")");
      }
   
       public void enleveStock (int qte){
         stock-=qte;
         System.out.println ("Fourmiliere "+id+" : nouveau stock = "+stock+" (-"+qte+")");
      }
   
       public int getPopulation() {
         return population;
      }
   
       public void augmentePopulation() {
         population++;
      }
   
       public void draw(Graphics g, double facteurZoom) {
         if ((polygon==null) || (oldfacteurZoom!=facteurZoom)) {
            oldfacteurZoom = facteurZoom ;
            polygon = new Polygon() ;
            int xbase = (int)(x*facteurZoom) ;
            int ybase = (int)(y*facteurZoom) ;
            int largeurbase = (int)(6*facteurZoom+6) ;
         // Triangle
            polygon.addPoint(xbase-largeurbase, ybase+largeurbase) ;
            polygon.addPoint(xbase+largeurbase, ybase+largeurbase) ;
            polygon.addPoint(xbase, ybase-largeurbase) ;
         }
         g.setColor(new Color (getRed(), getGreen(), getBlue()));
         g.fillPolygon(polygon) ;
      }
   }
