//------------------------------------------------------------
/**
 * SimAntMain : simulation de fourmilieres 2D/3D
 *
 *
 * Copyright (C) 2004  Olivier Grunder
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; see the file COPYING.  If not, write to
 *   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA 02111-1307, USA.
 *
 *   Contact: Olivier Grunder, 
 *            mailto:olivier.grunder@utbm.fr
 *            http://set.utbm.fr/membres/grunder/
 *
 *
 * @author      Olivier Grunder
 * @date        janvier 2004
 * @version     0.22
 *
 */
    class SimAntMain
   {
   
      private static int nfl = 2; // Nombre de fourmilires
      private static int nfm = 5; // Nombre de fourmis
      private static int nn = 20;  // Nombre de sources de nourriture
      private static int no = 20;  // Nombre d'obstacles
   	
      private static boolean flok = false;
      private static boolean fmok = false;
      private static boolean nok = false;
      private static boolean ook = false;
   
       public static void version() {
         System.out.println ("SimAnt Version 0.22") ;
         System.out.println () ;
      }
   
       public static void help() {
         version() ;
         System.out.println ("Usage : java SimAntMain [options]") ;
         System.out.println ("Options : -help -? -version -texte -2d -3d -gl4java -nfl x -nfm x -nn x -no x") ;
         System.out.println ("  -help    : affiche l'aide") ;
         System.out.println ("  -?       : affiche l'aide") ;
         System.out.println ("  -version : affiche la version") ;
         System.out.println ("  -texte   : affichage texte") ;
         System.out.println ("  -2d      : affichage 2d") ;
         System.out.println ("  -3d      : affichage 3d") ;
         System.out.println ("  -gl4java : affichage 3d (utilisation de gl4java)") ;
         System.out.println ("  -nfl x   : placer x fourmilieres (defaut : 2)") ;
         System.out.println ("  -nfm x   : placer x fourmis par fourmiliere (defaut : 5)") ;
         System.out.println ("  -nn x    : placer x sources de nourriture (defaut : 20)") ;
         System.out.println ("  -no x    : placer x obstacles (defaut : 20)") ;
         System.exit(0) ;
      }
   
       public static void main(String [] args)
      {
         int modeAffichage = SimAntJFrame.MODE_2D  ;  
         for (int i=0;i<args.length;i++) {
            if (args[i].equalsIgnoreCase("-texte"))   modeAffichage = SimAntJFrame.MODE_TEXTE ;
            if (args[i].equalsIgnoreCase("-?"))       modeAffichage = SimAntJFrame.MODE_TEXTE ;
            if (args[i].equalsIgnoreCase("-2d"))      modeAffichage = SimAntJFrame.MODE_2D ;
            if (args[i].equalsIgnoreCase("-3d"))      modeAffichage = SimAntJFrame.MODE_3D ;
            if (args[i].equalsIgnoreCase("-gl4java")) modeAffichage = SimAntJFrame.MODE_GL4JAVA ;
            if (args[i].equalsIgnoreCase("-help"))    help() ;
            if (args[i].equalsIgnoreCase("-vesrion")) version() ;
            if (args[i].equalsIgnoreCase("-nfl"))     nfl = Integer.parseInt(args[i+1]);
            if (args[i].equalsIgnoreCase("-nfm"))     nfm = Integer.parseInt(args[i+1]);
            if (args[i].equalsIgnoreCase("-nn"))      nn = Integer.parseInt(args[i+1]);
            if (args[i].equalsIgnoreCase("-no"))      no = Integer.parseInt(args[i+1]);
         }
      
         SimAntJFrame vihm=new SimAntJFrame("Simulation d'une fourmiliere - Luet & Couvidou", modeAffichage, nfl, nfm, nn, no);
      }
   }
